%% Initialization variables
clear all; clc;close all;


%location of the files
location1 ='C:\ALL\School\MQP\Beams sensitivity\Edge detection\img0004_1.tif';
location2 ='H:\MQP\Masking\img0004_1.tif';
location3 ='C:\\sample_dot_grid.bmp';


location=location1;



raw_data = imread(location);  %reads data
data_bits = raw_data(:,:,1);
[rows_data,cols_data,d] = size(raw_data);  %reads size of images

H = fspecial('gaussian');
I_sharp = imfilter(data_bits,H,'replicate');
%I_inv = inv(data_bits);
figure(1)
subplot(1,2,1)
imshow(data_bits);
title('original');
subplot(1,2,2)
imshow(I_sharp);
title('original sharp');


%% Detect edges on raw image

% 
% I_sobel_raw = edge(data_bits,'sobel');
% I_sobel_sharp_raw = edge(I_sharp,'sobel');
% I_canny_raw = edge(data_bits,'canny');
% I_canny_sharp_raw = edge(I_sharp,'canny');
% 
% figure(2)
% subplot(2,2,1)
% imshow(I_sobel_raw)
% title('sobel edge detection raw');
% subplot(2,2,2)
% imshow(I_sobel_sharp_raw)
% title('sobel sharp edge detection raw');
% subplot(2,2,3)
% imshow(I_canny_raw)
% title('canny edge detection raw');
% subplot(2,2,4)
% imshow(I_canny_sharp_raw)
% title('canny sharp edge detection raw');

%% covert to BW
I_bw_level = graythresh(data_bits);

I_bw = im2bw(data_bits,0.38);
I_bw_sharp = im2bw(I_sharp,I_bw_level);

figure(3)
subplot(1,2,1)
imshow(I_bw)
title('Black and white image');
subplot(1,2,2)
imshow(I_bw_sharp)
title('Black and white image   sharpened');

I3 = I_bw_sharp;


%% fill bw image 
I_filled = imfill(I3,'holes');

%H = fspecial('unsharp');
%I_filled_bw_sharp = imfilter(I_filled,H,'replicate');

figure(4)
%subplot(1,2,1)
imshow(I_filled);
title('BW filled');
%subplot(1,2,2)
%imshow(I_filled_bw_sharp);
%title('BW filled - sharpened');

I3_filled = I_filled;
 %% Detect edges on BW filled image

I3_uint8_filled = cast(I3_filled,'uint8');
%I3_uint8_filled_sharp = cast(I_filled_bw_sharp,'uint8');


I_filled_edges = edge(I3_uint8_filled,'canny');
%I_filled_BW_sharp = edge(I3_uint8_filled_sharp,'canny');

figure(5)
%subplot(1,2,1)
imshow(I_filled_edges)
title('canny edge detection on BW filled');
%subplot(1,2,2)
%imshow(I_filled_BW_sharp)
%title('canny edge detection on BW filled - sharpened');

%% boundary detection
[B1,L1] = bwboundaries(I_filled_edges,4,'noholes'); %data_bits,I_filled_BW
%s_center  = regionprops(L1, 'centroid');
%boundary_centroids = cat(1, s_center.Centroid);

figure(6)
imshow(data_bits)
title('boundaries of possible elements');
hold on
for k = 1:length(B1)
    boundary = B1{k};
    plot(boundary(:,2), boundary(:,1), 'g', 'LineWidth', 1)
    hold on
    %drawnow;
end
%plot(boundary_centroids(:,1), boundary_centroids(:,2), 'b+')


%% convert boundary image to BW image
%fill the holes in the image
L1_filled = imfill(L1,'holes');
%determine treshhold for BW conversion
I_filled_edges_bw_level = graythresh(L1_filled);
% convert to BW image
L1_filled_bw = im2bw(L1_filled,I_filled_edges_bw_level);

figure(7)
subplot(1,2,1)
imshow(L1_filled);
title('boundaries of possible elements');

subplot(1,2,2)
imshow(L1_filled_bw);
title('BW boundaries of possible elements');


%% find one boundary

% X_pos = 650;
% Y_pos = 650;
% 
% I3_filled_invr = ~I3_filled;
% boundary_1 = bwtraceboundary(I3_filled,[Y_pos, X_pos],'E');
% %boundary_1_sharp = bwtraceboundary(I_filled_bw_sharp,[Y_pos, X_pos],'N');
% 
% figure(7)
% %subplot(1,2,1)
% imshow(I3_filled)
% hold on;
% plot(boundary_1(:,2),boundary_1(:,1),'g','LineWidth',1);
% drawnow;
% title('boundary of BW image');
% 
% 
% % subplot(1,2,2)
% % imshow(I_filled_BW_sharp)
% % hold on;
% % plot(boundary_1_sharp(:,2),boundary_1_sharp(:,1),'g','LineWidth',1);
% % title('boundary of  sharpened BW image');





%% filter

%**** filter BW data w/o edge detection****************
L_unfiltered = bwlabel(I3_filled,4);


max_area = 4700;
min_area = 1800;

s_area  = regionprops(L_unfiltered, 'Area');
check =([s_area.Area]> min_area)&([s_area.Area]< max_area); 
idx = find(check);
I3_filled_filtered = ismember(L_unfiltered,idx);

%**** filter BW data w/ edge detection****************

L_unfiltered_edge = bwlabel(L1_filled_bw,4);

max_area_edge = 4700;
min_area_edge = 1980;

s_area_edge  = regionprops(L_unfiltered_edge, 'Area');
check_edge =([s_area_edge.Area]> min_area_edge)&...
    ([s_area_edge.Area]< max_area_edge); 
idx_edge = find(check_edge);
I3_filled_filtered_edge = ismember(L_unfiltered_edge,idx_edge);


figure(8);
subplot(2,1,1)
imagesc(I3_filled_filtered)
title('filtered BW regions');

subplot(2,1,2)
imagesc(I3_filled_filtered_edge)
title('filtered BW regions with edge detection');

filtering_ok = input('Do you want to use edge detection filtered data? Y/N [Y]: ','s');
if isempty(filtering_ok)
    filtering_ok = 'Y';
end  

if (filtering_ok == 'Y')
    I3_filled_filtered = I3_filled_filtered_edge; 
end
%% display resulting masking

L_filtered = bwlabeln(I3_filled_filtered,4);
s_center  = regionprops(L_filtered, 'centroid');
centroids = cat(1, s_center.Centroid);

data_masked = data_bits;


for i = 1:1:rows_data
    for j = 1:1:cols_data
        if (L_filtered(i,j)==0)
            data_masked(i,j) = 0;
        end 
    end
end

figure(9)
imshow(data_masked);
hold on
title('Resulting masking');
plot(centroids(:,1), centroids(:,2), 'g+')



%% region selection
selection_ok = 'N';

figure(10)
imagesc(L_filtered);
hold on
title('Please select desired region by entering the index of the region');
plot(centroids(:,1), centroids(:,2), 'g+')

while (selection_ok == 'N')
   
Region_index = input('What is the index of the desired region:   ');

L_desired = ismember(L_filtered,Region_index);

data_masked_desired = data_bits;
for i = 1:1:rows_data
    for j = 1:1:cols_data
        if (L_desired(i,j)==0)
            data_masked_desired(i,j) = 0;
        end 
    end
end

figure(11)
imshow(data_masked_desired);
hold on
title('Desired mask');
plot(centroids(Region_index,1), centroids(Region_index,2), 'g+')


% **************Create full mask ***************************************
Desired_object = bwlabeln(L_desired,4);
Stats_object = regionprops(Desired_object, 'centroid','Extrema');

center_col = Stats_object.Centroid(1,2);
center_row = Stats_object.Centroid(1,1);

trans_cols = 62;
trans_rows = 62;

border_width = 4;
border_lenght = 10;
border_buffer = 1;

T_mask_X = int32((Stats_object.Extrema(1,1)+ Stats_object.Extrema(2,1))/2);
T_mask_Y = int32((Stats_object.Extrema(1,2)+ Stats_object.Extrema(2,2))/2);

R_mask_X = int32((Stats_object.Extrema(3,1)+ Stats_object.Extrema(4,1))/2);
R_mask_Y = int32((Stats_object.Extrema(3,2)+ Stats_object.Extrema(4,2))/2);

B_mask_X = int32((Stats_object.Extrema(5,1)+ Stats_object.Extrema(6,1))/2);
B_mask_Y = int32((Stats_object.Extrema(5,2)+ Stats_object.Extrema(6,2))/2);

L_mask_X = int32((Stats_object.Extrema(7,1)+ Stats_object.Extrema(8,1))/2);
L_mask_Y = int32((Stats_object.Extrema(7,2)+ Stats_object.Extrema(8,2))/2);

mask_width = abs(B_mask_Y - T_mask_Y);
mask_lenght = abs(R_mask_X - L_mask_X);

inter_element_width = abs(trans_rows - mask_width);
rail_width = abs(inter_element_width - 2*border_width);

A_X = R_mask_X - border_buffer;
A_Y = T_mask_Y - border_width;

B_X = A_X - border_lenght;
B_Y = T_mask_Y + border_buffer;

C_X =  L_mask_X - border_buffer;
C_Y = A_Y - rail_width;

D_X = B_X;
D_Y = C_Y;

E_X = A_X;
E_Y = C_Y - border_width - border_buffer;


Full_mask_element = L_desired;
%patch lower border
Full_mask_element(A_Y:B_Y, B_X:A_X) = 1;
%patch rail  
Full_mask_element(C_Y:A_Y,C_X:A_X ) = 1;
%patch upper border
Full_mask_element(E_Y:D_Y, D_X:E_X) = 1;


data_masked_desired_full_element = data_bits;
for i = 1:1:rows_data
    for j = 1:1:cols_data
        if (Full_mask_element(i,j)==0)
            data_masked_desired_full_element(i,j) = 0;
        end 
    end
end

figure(12)
imshow(data_masked_desired_full_element);
grid on
hold on
title('Desired mask full element');
plot(centroids(Region_index,1), centroids(Region_index,2), 'g+')

%  **************** pattern mask ************************

X_center = centroids(Region_index,1);
X_total = cols_data;
X_delta = trans_rows;

Y_center = centroids(Region_index,2);
Y_total = rows_data;
Y_delta = trans_cols;


iterations_up = floor(Y_center/Y_delta) - 1;
iterations_down = floor(abs(Y_total - Y_center)/Y_delta);
iterations_left = floor(X_center/X_delta);
iterations_right = floor(abs(X_total - X_center)/X_delta) - 1;

total = data_masked_desired_full_element;


%transformations
se_down = translate(strel(1), [trans_cols 0]);
se_up = translate(strel(1), [-trans_cols 0]);
se_right = translate(strel(1), [0 trans_rows]);
se_left = translate(strel(1), [0 -trans_rows]);

% Pattern up
J_prev = data_masked_desired_full_element;
for i = 1:1:iterations_up
    J_next = imdilate(J_prev,se_up);
    total = (J_next | total);
    J_prev = J_next;
end


% Pattern down
J_prev = data_masked_desired_full_element;
for i = 1:1:iterations_down
    J_next = imdilate(J_prev,se_down);
    total = (J_next | total);
    J_prev = J_next;
end

%Pattern left
J_prev = total;
total_col = total;
for i = 1:1:iterations_left
    J_next = imdilate(J_prev,se_left);
    total = (J_next | total);
    J_prev = J_next;
end

% Pattern right
J_prev = total_col;
for i = 1:1:iterations_right
    J_next = imdilate(J_prev,se_right);
    total = (J_next | total);
    J_prev = J_next;
end




% mix real image with mask
data_masked_final = data_bits;
for i = 1:1:rows_data
    for j = 1:1:cols_data
        if (total(i,j)==0)
            data_masked_final(i,j) = 0;
        end 
    end
end

figure(13)
imshow(data_masked_final)
title('final result of masking');
hold on
plot(centroids(Region_index,1), centroids(Region_index,2), 'g+')

figure(14)
imshow(total)
title('final mask');
hold on
plot(centroids(Region_index,1), centroids(Region_index,2), 'g+')





selection_ok = input('Are you ok with your selection? Y/N [Y]: ','s');
if isempty(selection_ok)
    selection_ok = 'Y';
end   

end


%% output result

output_location_mask = 'C:\ALL\School\MQP\Beams sensitivity\Edge detection\img0004_1_mask.tif';
imwrite(total,output_location_mask,'tif', 'WriteMode', 'overwrite');

%% apply mask
%location of the files
location_target1 ='H:\MQP\Masking\img0006.tif';
location_target2 ='C:\ALL\School\MQP\Beams sensitivity\Edge detection\img0006.tif';


location_target=location_target2;

%read target image
raw_data_target = imread(location_target);  %reads data
data_target = raw_data_target(:,:,1);

% mix real image with mask
data_target_masked = data_target;
for i = 1:1:rows_data
    for j = 1:1:cols_data
        if (total(i,j)==0)
            data_target_masked(i,j) = 0;
        end 
    end
end

% save masked image
output_location_masked = 'C:\ALL\School\MQP\Beams sensitivity\Edge detection\img0006_masked.tif';
imwrite(data_target_masked,output_location_masked,'tif',...
    'WriteMode', 'overwrite');


